<?php
namespace Marwein\TestInlineTranslation\Domain\Model;


/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2014
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * InlineTest
 */
class InlineTest extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * title
	 * 
	 * @var string
	 */
	protected $title = '';

	/**
	 * falProperty
	 * 
	 * @var \TYPO3\CMS\Extbase\Domain\Model\FileReference
	 */
	protected $falProperty = NULL;

	/**
	 * inlineProperties
	 * 
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Marwein\TestInlineTranslation\Domain\Model\InlineProperty>
	 * @cascade remove
	 */
	protected $inlineProperties = NULL;

	/**
	 * __construct
	 */
	public function __construct() {
		//Do not remove the next line: It would break the functionality
		$this->initStorageObjects();
	}

	/**
	 * Initializes all ObjectStorage properties
	 * Do not modify this method!
	 * It will be rewritten on each save in the extension builder
	 * You may modify the constructor of this class instead
	 * 
	 * @return void
	 */
	protected function initStorageObjects() {
		$this->inlineProperties = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
	}

	/**
	 * Returns the title
	 * 
	 * @return string $title
	 */
	public function getTitle() {
		return $this->title;
	}

	/**
	 * Sets the title
	 * 
	 * @param string $title
	 * @return void
	 */
	public function setTitle($title) {
		$this->title = $title;
	}

	/**
	 * Returns the falProperty
	 * 
	 * @return \TYPO3\CMS\Extbase\Domain\Model\FileReference $falProperty
	 */
	public function getFalProperty() {
		return $this->falProperty;
	}

	/**
	 * Sets the falProperty
	 * 
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $falProperty
	 * @return void
	 */
	public function setFalProperty(\TYPO3\CMS\Extbase\Domain\Model\FileReference $falProperty) {
		$this->falProperty = $falProperty;
	}

	/**
	 * Adds a InlineProperty
	 * 
	 * @param \Marwein\TestInlineTranslation\Domain\Model\InlineProperty $inlineProperty
	 * @return void
	 */
	public function addInlineProperty(\Marwein\TestInlineTranslation\Domain\Model\InlineProperty $inlineProperty) {
		$this->inlineProperties->attach($inlineProperty);
	}

	/**
	 * Removes a InlineProperty
	 * 
	 * @param \Marwein\TestInlineTranslation\Domain\Model\InlineProperty $inlinePropertyToRemove The InlineProperty to be removed
	 * @return void
	 */
	public function removeInlineProperty(\Marwein\TestInlineTranslation\Domain\Model\InlineProperty $inlinePropertyToRemove) {
		$this->inlineProperties->detach($inlinePropertyToRemove);
	}

	/**
	 * Returns the inlineProperties
	 * 
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Marwein\TestInlineTranslation\Domain\Model\InlineProperty> $inlineProperties
	 */
	public function getInlineProperties() {
		return $this->inlineProperties;
	}

	/**
	 * Sets the inlineProperties
	 * 
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Marwein\TestInlineTranslation\Domain\Model\InlineProperty> $inlineProperties
	 * @return void
	 */
	public function setInlineProperties(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $inlineProperties) {
		$this->inlineProperties = $inlineProperties;
	}

}