<?php
namespace Marwein\TestInlineTranslation\Tests\Unit\Controller;
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014 
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Test case for class Marwein\TestInlineTranslation\Controller\InlineTestController.
 *
 */
class InlineTestControllerTest extends \TYPO3\CMS\Core\Tests\UnitTestCase {

	/**
	 * @var \Marwein\TestInlineTranslation\Controller\InlineTestController
	 */
	protected $subject = NULL;

	protected function setUp() {
		$this->subject = $this->getMock('Marwein\\TestInlineTranslation\\Controller\\InlineTestController', array('redirect', 'forward', 'addFlashMessage'), array(), '', FALSE);
	}

	protected function tearDown() {
		unset($this->subject);
	}

	/**
	 * @test
	 */
	public function listActionFetchesAllInlineTestsFromRepositoryAndAssignsThemToView() {

		$allInlineTests = $this->getMock('TYPO3\\CMS\\Extbase\\Persistence\\ObjectStorage', array(), array(), '', FALSE);

		$inlineTestRepository = $this->getMock('Marwein\\TestInlineTranslation\\Domain\\Repository\\InlineTestRepository', array('findAll'), array(), '', FALSE);
		$inlineTestRepository->expects($this->once())->method('findAll')->will($this->returnValue($allInlineTests));
		$this->inject($this->subject, 'inlineTestRepository', $inlineTestRepository);

		$view = $this->getMock('TYPO3\\CMS\\Extbase\\Mvc\\View\\ViewInterface');
		$view->expects($this->once())->method('assign')->with('inlineTests', $allInlineTests);
		$this->inject($this->subject, 'view', $view);

		$this->subject->listAction();
	}

	/**
	 * @test
	 */
	public function showActionAssignsTheGivenInlineTestToView() {
		$inlineTest = new \Marwein\TestInlineTranslation\Domain\Model\InlineTest();

		$view = $this->getMock('TYPO3\\CMS\\Extbase\\Mvc\\View\\ViewInterface');
		$this->inject($this->subject, 'view', $view);
		$view->expects($this->once())->method('assign')->with('inlineTest', $inlineTest);

		$this->subject->showAction($inlineTest);
	}
}
